unit MainUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  Buttons;

type
  TFrameClass = Class of TFrame;

type

  { TMainForm }

  TMainForm = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    FActiveFrame: TFrame;
  public
    Procedure SwitchToFrame(AFrameClass:TFrameClass);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

uses Unit1,Unit2,Unit3,Unit4;

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);

begin
  SwitchToFrame(TFrame1);
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  SwitchToFrame(TFrame1);
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
  SwitchToFrame(TFrame2);
end;

procedure TMainForm.SpeedButton3Click(Sender: TObject);
begin
  SwitchToFrame(TFrame3);
end;

procedure TMainForm.SpeedButton4Click(Sender: TObject);
begin
  SwitchToFrame(nil);
end;

procedure TMainForm.SpeedButton5Click(Sender: TObject);
begin
  SwitchToFrame(TFrame4);
end;

procedure TMainForm.SwitchToFrame(AFrameClass: TFrameClass);

begin
  if FActiveFrame is AFrameClass then exit; // no change
  if assigned(FActiveFrame) then FActiveFrame.parent := nil;  // hide previous frame
  if not assigned(AFrameClass) then exit;  // no new frame to display
  // Initialize frame if required and display it
  if AFrameClass = TFrame1 then
     begin
     If not assigned(Frame1) then
        Frame1 := TFrame1.Create(self);
     FActiveFrame := Frame1;
     end
  else if AFrameClass = TFrame2 then
     begin
     If not assigned(Frame2) then
        Frame2 := TFrame2.Create(self);
     FActiveFrame := Frame2;
     end
  else if AFrameClass = TFrame3 then
     begin
     If not assigned(Frame3) then
        Frame3 := TFrame3.Create(self);
     FActiveFrame := Frame3;
     end
  else
     assert(false,'TMainForm.SwitchToFrame: invalid frame class ' + AFrameClass.ClassName);
  FActiveFrame.Parent := self;
end;

end.

